#include <iostream>
#include <sstream>
#include "Robot.h"

    //Konstruktor
    Robot::Robot( void )
    {
        m_serial  = new Serial();
        m_camera  = new Camera();
        m_sensors = new Sensors( m_serial );

    	if (!robotOK()) return;
    	
        //verschiedene Initialisierungsversuche
        sendCommand(" "); //alles anhalten
        sendCommand("k"); //queue löschen
        sendCommand("J"); //Job verarbeitung starten
        sleep(10);
    	
    	gettimeofday( &m_stopTime, 0);
	
    }

    //Desturktor
    Robot::~Robot( )
    {
        delete m_camera;
        delete m_sensors;
        delete m_serial;
    }
    
    bool Robot::robotOK( void ) const
    {
        return ( m_serial->serialOK() /*&& m_camera->cameraOK()*/ && m_sensors->sensorsOK() );    
    }

    void Robot::waitForStop( void ) const
    {
        while (isMoving())
        {
            usleep(1000000);
        }
    }

    bool Robot::isMoving() const
    {
        sendCommand(">F1\n");  //Befehlsqueue abfragen
        string s="";
        string t;
        do
        {
           usleep(1000);
           t = m_serial->readData();
           s += t;
        } while (( t.length() > 0 ) || (s.length() == 0 ));
        
        return ( ((int)s.at( s.length()-1 )) != -1 );           
    }

    void Robot::sendCommand( const string s ) const
    {
        m_serial->writeData( s );
    }
    
	
