
#ifndef ROBOTINTERFACE_H_
#define ROBOTINTERFACE_H_

#include <fstream>
#include <sys/time.h>
#include "CameraInterface.h"
#include "SensorsInterface.h"

using namespace std;

class RobotInterface
{

    public:
	
        RobotInterface( void ) {};
        ~RobotInterface( void ) {};

        virtual bool robotOK( void ) const {};

        CameraInterface* getCamera() const;
        SensorsInterface* getSensors() const;

        void turn ( const float angle );
        void turn ( const float angle, const unsigned int speed);

        void drive ( const float distance );
        void drive ( const float distance, const unsigned int speed);

        void stop( void );

        virtual void waitForStop( void ) const {};

    protected:
	
        virtual void sendCommand( const string s ) const {};
    
        CameraInterface *m_camera;
        SensorsInterface *m_sensors;
        timeval m_stopTime;
    
        static const unsigned int NORMAL_SPEED=30;
        static const int PULSES_PER_METER=1000; //TODO:  kalibrieren!!
        static const int PULSES_PER_FULL_CIRCLE=800;
	
};

#endif /*ROBOTINTERFACE_H_*/
