#include "Sensors.h"
#include <sstream>

    //Konstruktor
    Sensors::Sensors( Serial *serial ) : SensorsInterface(), m_serial( serial )
    {
    }

    //Desturktor
    Sensors::~Sensors( void )
    {
    }
    
    bool Sensors::sensorsOK( void ) const
    {
        //TODO: Probeweise einen Sensor abfragen
        return true;
    }
    
    int Sensors::readSensor( int number )
    {

        //Buffer leeren, nichts altes lesen!        
        m_serial->clear();
        
        //Befehl zusammenbasteln und abschicken
        std::stringstream ss;
        ss << ">AD" << number << "\n";
        m_serial->writeData(ss.str());

        //Rueckgabe einlesen
        string wert = "";
        size_t pos;
        
        do
        {
            usleep(500);
            wert += m_serial->readData();
            pos = wert.find("\n",0);
        } while (pos == string::npos);  //Bis das 'Enter' kommt (nach >ADx)
            
        //jetzt die Zahlen einlesen
        wert = wert.substr( pos+1, wert.length()-pos-1 );
        int count = 0;
        while (!(  ( wert.length() >= 3 ) || ( count >=4 ) || ((wert.length()==2) && (wert.at(0)!='1') && (wert.at(0)!='2')) ))
        {
            usleep(500);
            wert += m_serial->readData();
            count++;
        }
            
        if (wert.length()==0) return 0;

        //string in int umwandeln        
        istringstream is(wert);
        int val;
        is >> val;
        //cout << "readSensor(" << number << ") : " << val << endl;

        return val;
    }

