
#include <opencv/cv.h>
#include <opencv/highgui.h>

#include "CameraInterface.h"
#include "Wall.h"

class SimulatedCamera : public CameraInterface
{
    public:
        SimulatedCamera( void );
        ~SimulatedCamera( void ) {};

        bool cameraOK( void ) const;
        IplImage* getImage( void );
        
        void move ( float distance );
        void turn ( float angle );
        
    private:
        double normalize( double a ) const;
    
        double m_x,m_y,m_angle;
        double m_ballX,m_ballY,m_ballSize;
        
        float *m_depth;
        int m_numberWalls;
        Wall *m_walls;

};

